/*
 * lefInt.h --
 *
 * This file defines things that are used by internal LEF routines in
 * various files.
 *
 * rcsid $Header: /ufs/repository/magic/lef/lefInt.h,v 1.1.1.1 2000/03/29 18:35:23 rajit Exp $
 */

#define _LEF

/* Some constants for LEF and DEF files */

#define LEF_LINE_MAX 2048  /* Maximum length fixed by LEF/DEF specifications */
#define LEF_MAX_ERRORS 100 /* Max # errors to report; limits output if */
                           /* something is really wrong about the file */

/* Struture used for returning information from a net route section */

typedef struct _linkedRoute {
   Point     p;
   TileType  type;
   struct    _linkedRoute *route_next;
} linkedRoute;

/* Struture used for returning information from a geometry section */

typedef struct _linkedRect {
   Rect      area;
   TileType  type;
   struct _linkedRect *rect_next;
} linkedRect;

/* External declaration of global variables */
extern int lefCurrentLine;

/* Forward declarations */

int lefDefInitFunc(), lefDefPushFunc();
FILE *lefFileOpen();

char *LefNextLine();
bool LefParseEndStatement();
void LefSkipSection();
CellDef *lefFindCell();
char *LefSkipToken();
char *LefLower();
linkedRect *LefReadGeometry();

void LefError(char *, ...);	/* Variable argument procedure requires */
				/* parameter list.			*/
